/* ***************************************************************************
   *                                                                         *
   *   Kindermann                        Wahlpflichtkurs Produktentwicklung  *
   *                                     Schuljahr: 2015-16                  *
   *                                                                         *
   *                                                                         *
   *                            Attiny85 ADC-Reader                          *
   *                                                                         *
   *                                                                         *
   ***************************************************************************/

#ifndef ADC_H
#define ADC_H

#include <usb.h>
#include <stdio.h>

#ifdef LINUX
	#include <unistd.h>
#else
	#include <windows.h>
#endif

#define	VENDOR_ID 0x16d0
#define	PRODUCT_ID 0x0753
#define USB_TIMEOUT 5000
#define RX_BUFFER_SIZE 64

// Voltage ref definition
#define VREF_VCC 0
#define VREF_1100mV 1
#define VREF_2560mV 2

// ADC Channels
#define ADC_PIN3 0
#define ADC_PIN2 1
#define ADC_TEMP_SENS 2

/* usbOpenDevice() error codes: */
#define USBOPEN_SUCCESS         0   /* no error */
#define USBOPEN_ERR_ACCESS      1   /* not enough permissions to open device */
#define USBOPEN_ERR_IO          2   /* I/O error */
#define USBOPEN_ERR_NOTFOUND    3   /* device not found */


void delay(unsigned int duration);

int usbGetStringAscii(usb_dev_handle *dev, int index, char *buf, int buflen);

int usbOpenDevice(usb_dev_handle **device, int vendorID, char *vendorNamePattern, int productID, char *productNamePattern, char *serialNamePattern, FILE *printMatchingDevicesFp, FILE *warningsFp);

extern int tbStatus;

typedef usb_dev_handle tinyboard;

tinyboard* tinyboard_connect();

void analog_init(tinyboard* tbHandle, unsigned char voltageRef);

unsigned int analogRead(tinyboard* tbHandle, unsigned char channel);

#endif
